﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;

namespace WG_SaveColumnPosInfo
{
    [Serializable]
    public struct ColumnInfo
    {
        private int position;
        private Size size;
        private SortIndicator sortIndicator;

        public ColumnInfo(UltraGridColumn column)
        {
            if (column == null)
                throw new ArgumentNullException();

            sortIndicator = column.SortIndicator;
            position = column.Header.VisiblePosition;

            size = new Size(column.Width, column.Header.Height);
        }

        public Size Size
        {
            get { return size; }
            set { size = value; }
        }

        public int Position
        {
            get { return position; }
            set { position = value; }
        }

        public SortIndicator SortIndicator
        {
            get { return sortIndicator; }
            set { sortIndicator = value; }
        }

    }
}
