﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;
using System.Text;
using System.Threading.Tasks;

namespace WG_SaveColumnPosInfo
{
    public class ColumnSerializationManager
    {
        private BinaryFormatter binaryFormatter;
        private SoapFormatter soapFormatter;

        private BinaryFormatter BinaryFormatter
        {
            get 
            {
                if (binaryFormatter == null)
                    binaryFormatter = new BinaryFormatter();

                return binaryFormatter; 
            }
        }

        private SoapFormatter SoapFormatter
        {
            get
            {
                if (soapFormatter == null)
                    soapFormatter = new SoapFormatter();

                return soapFormatter; 
            }
        }

        public void SerializeColumn(ColumnInfo info, bool xml, string filepath)
        {
            IFormatter formatter = null;

            if (xml)
                formatter = this.SoapFormatter;
            else
                formatter = this.BinaryFormatter;

            using (FileStream fs = new FileStream(filepath, FileMode.OpenOrCreate, FileAccess.Write))
            {
                formatter.Serialize(fs, info);
            }

        }
    }
}
