﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WG_SaveColumnPosInfo
{
    public partial class Form1 : Form
    {
        private ColumnSerializationManager serializationManager;

        public Form1()
        {
            InitializeComponent();
        }

        private ColumnSerializationManager SerializationManager
        {
            get 
            {
                if (serializationManager == null)
                    serializationManager = new ColumnSerializationManager();

                return serializationManager; 
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.SetUpGridDataSource();

            this.ultraComboEditor1.Items.Add("id");
            this.ultraComboEditor1.Items.Add("Name");
            this.ultraComboEditor1.Items.Add("Quantity");
            this.ultraComboEditor1.Items.Add("Price");
            this.ultraComboEditor1.Items.Add("Date");

            this.ultraComboEditor1.DropDownStyle = Infragistics.Win.DropDownStyle.DropDownList;
            

        }

        public void SetUpGridDataSource()
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(decimal));
            t1.Columns.Add("Date", typeof(DateTime));

            ds.Tables["table1"].Rows.Add(new Object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Appliances", 5, 90.4, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "FastFood", 20, 34.2, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Furniture", 12, 79.1, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Fruits", 25, 12.32, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Vegetables", 30, 13.5, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Cars", 13, 200.3, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Motorcycles", 10, 320.0, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Clothes", 40, 69.3, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Shoes", 24, 40.6, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Games", 53, 50.32, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Books", 42, 22.12, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Movies", 38, 19.43, new DateTime(2009, 02, 28) });

            ultraGrid1.DataSource = ds;
        }

        private string GetDefaultFilePath()
        {
            if (this.ultraCheckEditor1.Checked)
                return @"..\..\test.xml";
            else
                return @"..\..\test.bin";
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            if(this.ultraComboEditor1.SelectedIndex == -1)
            {
                MessageBox.Show("Please select a column from the combo!");
                return;
            }

            var column = this.ultraGrid1.DisplayLayout.Bands[0].Columns[this.ultraComboEditor1.Value.ToString()];
            
            var columnInfo = new ColumnInfo(column);
            var filePath = this.GetDefaultFilePath();
            var xml = this.ultraCheckEditor1.Checked;

            this.SerializationManager.SerializeColumn(columnInfo, xml, filePath);

            MessageBox.Show("The chosen column was serialized. You can view the result at: " + filePath);
        }
    }
}
